﻿using System;

namespace SharpChat.Users {
    public interface IUser : IEquatable<IUser> {
        /// <summary>
        /// Unique ID of the user
        /// </summary>
        long UserId { get; }

        /// <summary>
        /// Default unique name of the user
        /// </summary>
        string UserName { get; }

        /// <summary>
        /// Display colour of the user
        /// </summary>
        Colour Colour { get; }

        /// <summary>
        /// Hierarchical rank of the user
        /// </summary>
        int Rank { get; }

        /// <summary>
        /// Permissions the user has
        /// </summary>
        UserPermissions Permissions { get; }
    }
}
